#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include "base64.h"

//#define GET_DECODE_TABLE
//#define CHECK_PROG

static unsigned char encode_table[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

static unsigned char decode_table[] = {
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,62, 0, 0, 0,63,
	52,53,54,55,56,57,58,59,60,61, 0, 0, 0, 0, 0, 0,
	 0, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,
	15,16,17,18,19,20,21,22,23,24,25, 0, 0, 0, 0, 0,
	 0,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
	41,42,43,44,45,46,47,48,49,50,51, 0, 0, 0, 0, 0
};

void encode(unsigned char *src, int num_data, unsigned char *dest)
{
	unsigned long data = 0;
	int i, j = 0;
	
	for(i = 0;i < num_data;i ++){
		j ++;
		data <<= 8;
		data |= *src++;
		if (j == 3){
			*dest++ = encode_table[(data >> 18) & 0x3F];
			*dest++ = encode_table[(data >> 12) & 0x3F];
			*dest++ = encode_table[(data >>  6) & 0x3F];
			*dest++ = encode_table[(data      ) & 0x3F];
			j = 0;
			data = 0;
		}
	}
	if (j == 2){
		data <<= 8;
		*dest++ = encode_table[(data >> 18) & 0x3F];
		*dest++ = encode_table[(data >> 12) & 0x3F];
		*dest++ = encode_table[(data >>  6) & 0x3F];
		*dest++ = '=';
	} else if (j == 1){
		data <<= 16;
		*dest++ = encode_table[(data >> 18) & 0x3F];
		*dest++ = encode_table[(data >> 12) & 0x3F];
		*dest++ = '=';
		*dest++ = '=';
	}
	*dest = 0;
}

int decode(unsigned char *src, int max_data, unsigned char *dest)
{
	unsigned long data;
	int i, len, res = 0;
	
	len = strlen((char *)src);
	if ((len > max_data * 4 / 3)||(len % 4)) return -1;

	for(i = 0;i < len;i += 4){
		data = 0;
		if (i == (len - 1)){
			if (src[1] == '='){
				data  = decode_table[*src++] << 18;
				data |= decode_table[*src++] << 12;
				*dest++ =  data >> 16;
				res += 2;
				break;
			} else if (src[2] == '='){
				data  = decode_table[*src++] << 18;
				data |= decode_table[*src++] << 12;
				data |= decode_table[*src++] <<  6;
				*dest++ =  data >> 16;
				*dest++ = (data >>  8) & 0xff;
				res += 1;
				break;
			}
		}
		data  = decode_table[*src++] << 18;
		data |= decode_table[*src++] << 12;
		data |= decode_table[*src++] <<  6;
		data |= decode_table[*src++];
		*dest++ =  data >> 16;
		*dest++ = (data >>  8) & 0xff;
		*dest++ =  data        & 0xff;
		res += 3;
	}
	return res;
}

#ifdef GET_DECODE_TABLE
int main(int argc, char **argv){
	int i, j;
	unsigned char table[128];

	memset(table, 0, 128);
	for(i = 0;i < 64; i ++){
		table[encode_table[i]] = i;
	}
	for(i = 0;i < 8; i ++){
		for(j = 0;j < 16; j ++){
			printf("%2d,",table[i*16+j]);
		}
		printf("\n");
	}
}
#endif

#ifdef CHECK_PROG
int main(int argc, char **argv){
	char buf[] = "Hello World!";
	char str[100], str2[100];

	encode(buf, sizeof(buf), str);
	printf("encode : [%s]\n", str);
	decode(str ,100,  str2);
	printf("decode : [%s]\n", str2);
}
#endif
