#ifndef  _CONTROL_RISK_CONFIG_H__
#define  _CONTROL_RISK_CONFIG_H__

#include <string>

#include "baseRTC.h"
#include "GridMap.h"

using namespace std;
using namespace baseRTC;

class ControlRiskConfig{
public:

	/** コンストラクタ
	 */
	ControlRiskConfig();

	/** デストラクタ
	 */
	~ControlRiskConfig();

	/** データをファイルへ書き出す
	 *
	 * @param[in] filename 書き込むファイル名
	 * @return 成功時は0, 失敗時はそれ以外を返す
	 */
	int SaveToFile(string filename);

	/** ファイルらからデータを読み込む
	 *
	 * @param[in] xml 読み込むファイル名
	 * @return 成功時は0, 失敗時はそれ以外を返す
	 */
	int LoadFromFile(string filename);

	/** ostream へ << 演算子で内容出力用
	 *
	 * cout << Config; と言った使い方を可能にする.
	 */
	friend std::ostream& operator<<(std::ostream& os, const ControlRiskConfig& ctrl_risk);

	string category; ///< カテゴリ名
	string name;     ///< コンポーネント名
	string id;       ///< コンポーネントID

	vector<string> receive; ///< 受信するデータのリスト (送信元ID)

	int input_number; ///< 入力ポート数

	double timeout; ///< タイムアウト設定

	GridMap grid_map; ///< 存在確率マップ (area, grid_size, rangeのみ使用)

	bool gui; ///< GUI表示設定

private:
};


#endif //_ENV_RECOGNITION_CONFIG_H__

