#ifndef ESTIMATE_RISK_H
#define ESTIMATE_RISK_H

#include <string>
#include <vector>

#include "GridMap.h"
#include "Object.h"
#include "Localization.h"
#include "RobotParam.h"

using namespace std;

// CEstimateRisk
/** 複数の距離センサーデータから、存在確率マップを生成するクラス
 */
class CEstimateRisk
{
public:
	CEstimateRisk();
	virtual ~CEstimateRisk();

	// 初期化
	int init();
	
	// 入力
	// 存在確率グリッドマップの登録
	//int setGridMap(struct grid_map_T *gmap);
	int setGridMap(GridMap *gmap);
	
	// 特定障害物の登録
	//int setObject(struct object_T *obj);
	int setObject(DetectObject *objs);
	
	// ロボットの自己位置・速度の登録
	//int setSelfLocalization(struct self_localization_T *sloc);
	int setSelfLocalization(Localization *sloc);

	// ロボットのパラメータの登録
	int setRobotPara(RobotParam *rpara);

	// タイムアウト（これ以上前のデータは考慮しない）
	int setTimeOut(double tout);

	// 出力
	// 衝突リスクを加味した障害物グリッドマップ
	//int getRiskGridMap(struct grid_map_T *rgmap);
	int getRiskGridMap(GridMap *rgmap);
	
	// 終了処理
	int close();

private:
	GridMap grid_map;
	DetectObject object;
	Localization self_loc;

	RobotParam robot_para;
	double time_out;
};

#endif // ESTIMATE_RISK_H
